#ifndef IKD_OX_BASIC_OXMAP_H
#define IKD_OX_BASIC_OXMAP_H

// }bvNX
//
//  }bvNXłByANXɒ`Ă܂B
//  }bvNX͓̃C^[tFCXĂāA}yPCu
//  ׂẴ}bv͂̃NXgpĂ܂B
//  WindowsvbgtH[ȂSTL::mapŏ\̂߁AłSTLmapbvĂ܂A
//  STLgȂCuŗLmapꍇ́A̗ɂȂăC^[tFCXۂ
//  ΑΉł͂łB

#ifdef WIN32
#	include <map>
#endif

namespace OX {
	// yANX
	//  C++STL̃Ce[^bvłB
	//  \bhł΂̃NX̗ɂȂČŗLCudlɒuł܂
	template<class Key, class Val>
	class Pair {
		template<class Key, class Val> friend class Map;
		typename std::map<Key, Val>::iterator it;
		std::map<Key, Val> &map;

		// RXgN^
		//  ̃RXgN^MapNXɂ̂݌JĂ܂
		Pair(std::map<Key, Val> &map) : map(map), it(map.begin()) {}
		Pair(std::map<Key, Val> &map, typename std::map<Key, Val>::iterator &it) : map(map), it(it) {}

	public:
		// I[ɒBH
		bool isEnd() {
			return it == map.end();
		}
		// ̃Ce[^
		Pair &next() {
			it++;
			return *this;
		}
		// first
		//  Key̒l͕ύXƋ̂ŒlԂ
		Key first() {
			return it->first;
		}

		// second
		//  Val͒ułOKȂ̂ŎQƕԂ
		Val &second() {
			return it->second;
		}

		// 폜
		void remove() {
			if (!isEnd())
				it = map.erase(it);
		}
	};

	// }bvNX
	//  C++STL̃Ce[^bvłB
	//  ŗLCuɑΉɂ́A\bhƋ@\NXŉ̎㏑܂B
	template<class Key, class Val>
	class Map {
		std::map<Key, Val> map_;

	public:
		// JnyA擾
		Pair<Key, Val> begin() {
			return Pair<Key, Val>(map_);
		}
		// 
		Pair<Key, Val> find(Key &key) {
			return Pair<Key, Val>(map_, map_.find(key));
		}
		Pair<Key, Val> find(const Key &key) {
			return Pair<Key, Val>(map_, map_.find(key));
		}
		// o^
		void insert(const Key &key, const Val &val, bool replace = false) {
			if (replace) {
				std::map<Key, Val>::iterator it = map_.find(key);
				if (it != map_.end()) {
					it->second = val;
					return;
				}
			}
			map_.insert(std::pair<Key, Val>(key, val));
		}
		void insert(Key &key, const Val &val) {
			map_.insert(std::pair<Key, Val>(key, val));
		}
		Val &operator[](const Key &key) {
			Pair<Key, Val> pair = find(key);
			if (pair.isEnd()) {
				insert(key, Val());
				Pair<Key, Val> pair = find(key);
				return pair.second();
			}
			return pair.second();
		}
		Val &operator[](Key &key) {
			Pair<Key, Val> pair = find(key);
			if (pair.isEnd()) {
				insert(key, Val());
				Pair<Key, Val> pair = find(key);
				return pair.second();
			}
			return pair.second();
		}
		// 폜
		void remove(Key &key) {
			map_.erase(key);
		}
		void remove(const Key &key) {
			map_.erase(key);
		}
		// TCY
		unsigned size() const {
			return (unsigned)map_.size();
		}
	};
}

#endif